; Two implementations of factorial using recursive procedures.
; One implementation generates a recursive process,
; the other generates an iterative process.

; linear recursive

(define (facta n)
  (if (= n 1)
      1.
      (* n (facta (- n 1)))))

; iterative

(define (factb n)
  (define (iter prod count)
    (if (> count n)
        prod
        (iter (* count prod) (+ count 1))))
  (iter 1. 1))
